/* -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */
/*
 * This library is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library. If not, see <http://www.gnu.org/licenses/>.
 */

#if !defined (__LIBICAL_GLIB_H_INSIDE__) && !defined (LIBICAL_GLIB_COMPILATION)
#error "Only <libical-glib/libical-glib.h> can be included directly."
#endif

#ifndef I_CAL_DATETIMEPERIOD_TYPE_H
#define I_CAL_DATETIMEPERIOD_TYPE_H

#include <libical-glib/i-cal-timetype.h>
#include <libical-glib/i-cal-period-type.h>
#include <libical-glib/i-cal-object.h>

G_BEGIN_DECLS

#define I_CAL_DATETIMEPERIOD_TYPE_TYPE \
        (i_cal_datetimeperiod_type_get_type ())
#define I_CAL_DATETIMEPERIOD_TYPE(obj) \
        (G_TYPE_CHECK_INSTANCE_CAST \
        ((obj), I_CAL_DATETIMEPERIOD_TYPE_TYPE, ICalDatetimeperiodType))
#define I_CAL_DATETIMEPERIOD_TYPE_CLASS(klass) \
        (G_TYPE_CHECK_CLASS_CAST \
        ((klass), I_CAL_DATETIMEPERIOD_TYPE_TYPE, ICalDatetimeperiodTypeClass))
#define I_CAL_IS_DATETIMEPERIOD_TYPE(obj) \
        (G_TYPE_CHECK_INSTANCE_TYPE \
        ((obj), I_CAL_DATETIMEPERIOD_TYPE_TYPE))
#define I_CAL_IS_DATETIMEPERIOD_TYPE_CLASS(klass) \
        (G_TYPE_CHECK_CLASS_TYPE \
        ((klass), I_CAL_DATETIMEPERIOD_TYPE_TYPE))

/**
 * ICalDatetimeperiodType:
 *
 * This is the ICalDatetimeperiodType instance.
 */
typedef struct _ICalDatetimeperiodType ICalDatetimeperiodType;

/**
 * ICalDatetimeperiodTypeClass:
 *
 * This is the ICalDatetimeperiodType class.
 */
typedef struct _ICalDatetimeperiodTypeClass ICalDatetimeperiodTypeClass;

struct _ICalDatetimeperiodType {
	/*< private >*/
	ICalObject parent;
};

struct _ICalDatetimeperiodTypeClass {
	/*< private >*/
	ICalObjectClass parent;
};

typedef struct _ICalTimetype ICalTimetype;
typedef struct _ICalPeriodType ICalPeriodType;

ICalDatetimeperiodType *
		i_cal_datetimeperiod_type_new_full
						(struct icaldatetimeperiodtype native);
GType 		i_cal_datetimeperiod_type_get_type
						(void);
struct icaldatetimeperiodtype 
		i_cal_datetimeperiod_type_new_default
						(void);
ICalTimetype *	i_cal_datetimeperiod_type_get_time
						(ICalDatetimeperiodType *dtp);
void		i_cal_datetimeperiod_type_set_time
						(ICalDatetimeperiodType *dtp,
						 ICalTimetype *time);
ICalPeriodType *
		i_cal_datetimeperiod_type_get_period
						(ICalDatetimeperiodType *dtp);
void		i_cal_datetimeperiod_type_set_period
						(ICalDatetimeperiodType *dtp,
						 ICalPeriodType *period);

G_END_DECLS

#endif /* I_CAL_DATETIMEPERIOD_TYPE_H */